; Source code assembled with Pelles Macro Assembler, Version 8.00.1

.model flat,fastcall

include     ColorDlg.inc

.data

Resource    db 'MYDIALOG',0
msg         db 'Dialog box example',0
title1      db 'About',0

.data?

hBrush      qword ?

.code

start PROC PARMAREA=5*QWORD

LOCAL hModule:QWORD

	invoke GetModuleHandle,NULL
        mov    hModule,rax
	invoke DialogBoxParam,hModule,ADDR Resource,NULL,ADDR DlgProc,NULL
	invoke ExitProcess,rax

start ENDP

DlgProc PROC hWnd:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD PARMAREA=12*QWORD

LOCAL _hWnd:QWORD

    mov _hWnd,rcx

    .IF edx==WM_CTLCOLORDLG
    
        invoke  CreateSolidBrush,Blue
        mov     [rip+hBrush],rax
        ret

    .ELSEIF edx==WM_CLOSE
    
        invoke  SendMessage,rcx,WM_COMMAND,IDM_EXIT,0

    .ELSEIF edx==WM_COMMAND
		
        mov rax,r8
        
        .IF r9==0
        
            .IF ax==IDM_ABOUT
            
                invoke MessageBox,NULL,ADDR msg,ADDR title1,MB_OK
                        
            .ELSEIF ax==IDM_EXIT
            
                @@:
                invoke DeleteObject,[rip+hBrush]
                invoke EndDialog,_hWnd,NULL
                
            .ENDIF
            
        .ELSE
        
            mov rdx,r8
            shr edx,16
            
            .IF dx==BN_CLICKED
                                
                .IF ax==IDC_ABOUT
                
                    invoke SendMessage,_hWnd,WM_COMMAND,IDM_ABOUT,0
                            
                .ELSEIF ax==IDC_EXIT
                
                     invoke SendMessage,_hWnd,WM_COMMAND,IDM_EXIT,0
                    
                .ENDIF
            .ENDIF
        .ENDIF
    .ELSE
    
        mov rax,FALSE
        ret
        
    .ENDIF
    
    mov rax,TRUE
    ret
    
DlgProc ENDP

END start

