include ScrollDemo.inc

.data

DlgBox  db 'DLGBOX',0
TextMsg db '      This is a scrolling text message ',0
CharPos dq 0

.data?

hBrush      qword ?

.code

start PROC

    invoke  GetModuleHandle,0
    invoke  DialogBoxParam,rax,ADDR DlgBox,0,ADDR DlgProc,0
    invoke  ExitProcess,rax

start ENDP

DlgProc PROC hWnd:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD

LOCAL hdc:QWORD
LOCAL ps:PAINTSTRUCT
LOCAL rc:RECT 

    mov    hWnd,rcx

    .IF edx==WM_INITDIALOG

        invoke    SetTimer,rcx,ID_TIMER,200,ADDR TimerProc

    .ELSEIF edx==WM_CTLCOLORDLG

        invoke	  CreateSolidBrush,White
        mov       hBrush,rax
        ret

    .ELSEIF edx==WM_CLOSE

        invoke    EndDialog,hWnd,0

    .ELSEIF edx==WM_PAINT

        invoke    BeginPaint,hWnd,ADDR ps
        mov       hdc,rax
        invoke    GetClientRect,hWnd,ADDR rc
        mov       rc.left,100
        mov       rdx,OFFSET TextMsg
        add       rdx,CharPos
        mov       r8,39
        sub       r8,CharPos
        invoke    DrawText,hdc,rdx,r8,ADDR rc,0
        invoke    EndPaint,hWnd,ADDR ps 

    .ELSE

        xor rax,rax
        ret

    .ENDIF

    mov    rax,TRUE
    ret

DlgProc ENDP

TimerProc PROC hWnd:QWORD,uMsg:QWORD,idEvent:QWORD,dwTime:QWORD

        mov    hWnd,rcx
        cmp     CharPos,38
        jne     @f
        invoke  KillTimer,hWnd,ID_TIMER
        ret
@@:
        inc     CharPos
        invoke  InvalidateRect,hWnd,0,TRUE
        ret

TimerProc ENDP

END start
